'use strict';

var run = function () {
  var _ref = _asyncToGenerator( /*#__PURE__*/regeneratorRuntime.mark(function _callee(programArgs) {
    var _yargs$usage$help$ali, argv;

    return regeneratorRuntime.wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            _yargs$usage$help$ali = yargs(programArgs || process.argv.slice(2)).usage(args.usage).help('h').alias('help', 'h').options(args.options).demandOption(['errorEventFile']).epilogue(args.docs).wrap(Math.min(100, process.stdout.columns)), argv = _yargs$usage$help$ali.argv;


            if (argv.help) {
              yargs.showHelp();
              process.on('exit', function () {
                return process.exit(1);
              });
            }

            _context.prev = 2;
            _context.next = 5;
            return runSourceMapResolver(argv);

          case 5:
            _context.next = 11;
            break;

          case 7:
            _context.prev = 7;
            _context.t0 = _context['catch'](2);

            process.stdout.write(chalk.bold.red(util.format(_context.t0)));
            process.on('exit', function () {
              return process.exit(1);
            });

          case 11:
          case 'end':
            return _context.stop();
        }
      }
    }, _callee, this, [[2, 7]]);
  }));

  return function run(_x) {
    return _ref.apply(this, arguments);
  };
}();

function _asyncToGenerator(fn) { return function () { var gen = fn.apply(this, arguments); return new Promise(function (resolve, reject) { function step(key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { return Promise.resolve(value).then(function (value) { step("next", value); }, function (err) { step("throw", err); }); } } return step("next"); }); }; }

var yargs = require('yargs');
var runSourceMapResolver = require('./index');
var util = require('util');
var chalk = require('chalk');

var args = {
  options: {
    mapFiles: {
      alias: 'm',
      description: 'List of paths to source map files',
      type: 'array'
    },
    errorEventFile: {
      alias: 'e',
      description: 'Path to error event file',
      type: 'string'
    },
    printSourceLine: {
      alias: 'print-source-line',
      description: 'Print source code line',
      type: 'bool'
    }
  },
  usage: 'Usage: $0 --mapFiles <pathToMapFile1> <pathToMapFile2> --errorEventFile <pathToErrorEventFile>',
  docs: 'Documentation:\nhttps://github.com/NDLANO/frontend-packages/tree/ndla-source-map-resolver/packages/ndla-source-map-resolver'
};

exports.run = run;